PROGRAM ReeAccess3;

USES WinTypes, WinProcs, WObjects, ReeFace;

{$R ReeXs3}

TYPE
  PMyWindow = ^TMyWindow;
  TMyWindow = OBJECT (TWindow)
    CONSTRUCTOR Init (AParent: PWindowsObject; ATitle: PChar);
    PROCEDURE GetWindowClass (VAR AWndClass: TWndClass); VIRTUAL;
    PROCEDURE SetupWindow; VIRTUAL;
    PROCEDURE Destroy; VIRTUAL;
    PROCEDURE WMTimer (VAR Msg: TMessage); VIRTUAL wm_First + wm_Timer;
  END;

  TMyApplication = OBJECT (TApplication)
    PROCEDURE InitMainWindow; VIRTUAL;
    PROCEDURE InitInstance; VIRTUAL;
  END;

CONSTRUCTOR TMyWindow.Init (AParent: PWindowsObject; ATitle: PChar);
BEGIN
  TWindow.Init (AParent, ATitle);
END;

PROCEDURE TMyWindow.GetWindowClass (VAR AWndClass: TWndClass);
BEGIN
  TWindow.GetWindowClass (AWndClass);
  AWndClass.hIcon := LoadIcon (hInstance, 'ReeXs3');
END;

PROCEDURE TMyWindow.SetupWindow;
BEGIN
  TWindow.SetupWindow;
  ShowWindow (HWindow, sw_ShowMinNoActive);
  SetTimer (HWindow, 3, 10000, NIL);
END;

PROCEDURE TMyWindow.Destroy;
BEGIN
  KillTimer (HWindow, 3);
  TWindow.Destroy;
END;

PROCEDURE TMyWindow.WMTimer (VAR Msg: TMessage);
BEGIN
  IF (Msg.wParam = 3) THEN
    ReeFace.SetValue (10);
END;

PROCEDURE TMyApplication.InitMainWindow;
BEGIn
  MainWindow := New (PMyWindow, Init(NIL, 'Set Value to 10'));
END;

PROCEDURE TMyApplication.InitInstance;
BEGIN
  InitMainWindow;
  MainWindow := MakeWindow(MainWindow);
  IF (MainWindow <> NIL)
    THEN MainWindow^.Show (sw_ShowMinNoActive)
    ELSE Status := em_InvalidMainWindow;
END;

VAR
  GenericApp: TMyApplication;

BEGIN
  GenericApp.Init ('ReeAccess 3');
  GenericApp.Run;
  GenericApp.Done;
END.